VERSION 5.00
Begin VB.UserControl ucChat 
   BackColor       =   &H8000000E&
   ClientHeight    =   3915
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4800
   ScaleHeight     =   261
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   320
   Begin Proyecto1.ucScrollbar ucScrollbar1 
      Height          =   3375
      Left            =   3840
      TabIndex        =   1
      Top             =   120
      Visible         =   0   'False
      Width           =   135
      _ExtentX        =   238
      _ExtentY        =   5953
      ShowButtons     =   0   'False
      AutoHidden      =   -1  'True
      HookContainer   =   -1  'True
   End
   Begin VB.Label lblTimeStamp 
      Alignment       =   1  'Right Justify
      AutoSize        =   -1  'True
      BackStyle       =   0  'Transparent
      Caption         =   "Time Stamp"
      BeginProperty Font 
         Name            =   "Source Sans Pro"
         Size            =   9
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H00999999&
      Height          =   225
      Index           =   0
      Left            =   0
      TabIndex        =   4
      Top             =   0
      Visible         =   0   'False
      Width           =   4635
   End
   Begin VB.Label lblUserName 
      AutoSize        =   -1  'True
      BackStyle       =   0  'Transparent
      Caption         =   "User Name"
      BeginProperty Font 
         Name            =   "Source Sans Pro Semibold"
         Size            =   9
         Charset         =   0
         Weight          =   600
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   225
      Index           =   0
      Left            =   0
      TabIndex        =   3
      Top             =   0
      Visible         =   0   'False
      Width           =   825
   End
   Begin Proyecto1.LabelPlus lbpPhoto 
      Height          =   600
      Index           =   0
      Left            =   0
      TabIndex        =   2
      Top             =   270
      Visible         =   0   'False
      Width           =   600
      _ExtentX        =   1058
      _ExtentY        =   1058
      BackColor       =   13421772
      Border          =   -1  'True
      BorderColor     =   13421772
      BorderCornerLeftTop=   20
      BorderCornerRightTop=   20
      BorderCornerBottomRight=   20
      BorderCornerBottomLeft=   20
      BorderWidth     =   1
      Caption         =   "ucChat.ctx":0000
      CaptionPaddingX =   5
      CaptionPaddingY =   5
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "Arial"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Gradient        =   -1  'True
      GradientColor1  =   16316150
      GradientColor2  =   15591912
      PictureAlignmentH=   1
      PictureAlignmentV=   1
      PictureSetWidth =   40
      PictureSetHeight=   40
      ShadowColorOpacity=   20
      CallOutAlign    =   0
      CallOutWidth    =   5
      CallOutRightTriangle=   -1  'True
      BeginProperty IconFont {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      PictureArr      =   0
   End
   Begin Proyecto1.LabelPlus lbpMessage 
      Height          =   600
      Index           =   0
      Left            =   600
      TabIndex        =   0
      Top             =   270
      Visible         =   0   'False
      Width           =   1260
      _ExtentX        =   2223
      _ExtentY        =   1058
      BackColor       =   13421772
      Border          =   -1  'True
      BorderColor     =   13421772
      BorderCornerLeftTop=   4
      BorderCornerRightTop=   4
      BorderCornerBottomRight=   4
      BorderCornerBottomLeft=   4
      BorderWidth     =   1
      Caption         =   "ucChat.ctx":0020
      CaptionPaddingX =   5
      CaptionPaddingY =   5
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "Arial"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Gradient        =   -1  'True
      GradientColor1  =   16316150
      GradientColor2  =   15591912
      PictureSetWidth =   40
      PictureSetHeight=   40
      ShadowSize      =   2
      ShadowOffsetX   =   1
      ShadowOffsetY   =   1
      ShadowColorOpacity=   20
      CallOutAlign    =   3
      CallOutWidth    =   8
      CallOutLen      =   6
      CallOut         =   -1  'True
      CallOutCustomPosition=   13
      BeginProperty IconFont {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      PictureArr      =   0
   End
End
Attribute VB_Name = "ucChat"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
'Autor: Leandro Ascierto
'Module Name: ucChat
'Date: 23/12/2019
'Contributors: Alberto Miano
Private Const WM_SETREDRAW As Long = &HB&

Private m_Heigth As Long
Private DpiZoom As Long
Private MarginTop As Long

Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Private Declare Function RedrawWindow Lib "user32.dll" (ByVal hwnd As Long, ByRef lprcUpdate As Any, ByVal hrgnUpdate As Long, ByVal fuRedraw As Long) As Long

Public Function TimeStamp() As String
  TimeStamp = Day(Now) & " " & CapitalizeFirstWord(MonthName(Month(Now), True), False) & " " & Format(Now, "hh:mm am/pm")
End Function

Public Sub AddMsg(ByVal sUserName As String, ByVal sImage As String, ByVal sMsg As String, Optional IsMe As Boolean = False, Optional sTimeStamp As Boolean = True)
  Dim i As Long
  
  Call SendMessage(UserControl.hwnd, WM_SETREDRAW, 0&, 0&)
  
  '// User name
  Load lblUserName(lblUserName.Count)
  With lblUserName(lblUserName.Count - 1)
    .Width = UserControl.ScaleWidth - ucScrollbar1.Width '/ (1.2 * DpiZoom)
    .Caption = sUserName

    If IsMe Then
      .Left = UserControl.ScaleWidth - ucScrollbar1.Width - .Width
    End If

    .Visible = True
  End With
  
  '// Time stamp
  Load lblTimeStamp(lblTimeStamp.Count)
  With lblTimeStamp(lblTimeStamp.Count - 1)
    .Width = UserControl.ScaleWidth - ucScrollbar1.Width '/ 1.1
    .Caption = IIf(sTimeStamp, TimeStamp, vbNullString)

    If IsMe Then
      .Left = UserControl.ScaleWidth - ucScrollbar1.Width - .Width - 258 * DpiZoom
    End If

    .Visible = True
  End With
  
  '// Photo
  Load lbpPhoto(lbpPhoto.Count)
  With lbpPhoto(lbpPhoto.Count - 1)
    .Width = 40 * DpiZoom
    .Height = 40 * DpiZoom
    
    .PictureSetWidth = 40
    .PictureSetHeight = 40
    .PictureFromURL sImage, True
    
    If IsMe Then
      .Left = UserControl.ScaleWidth - ucScrollbar1.Width - .Width
    End If
    
    .Visible = True
  End With
  
  '// Message
  Load lbpMessage(lbpMessage.Count)
  With lbpMessage(lbpMessage.Count - 1)
    .Width = UserControl.ScaleWidth / 1.2
    .Caption = sMsg
    .AutoSize = True
    
    If IsMe Then
      .Left = UserControl.ScaleWidth - ucScrollbar1.Width - .Width - lbpPhoto(0).Width
      .CallOutPosicion = coRight
      .GradientColor1 = &H93F486
      .GradientColor2 = &H53EF4B
      .BorderColor = &H15B544
    End If
    
    .Visible = True
  End With
  
    
  m_Heigth = 0
  For i = 1 To lbpMessage.Count - 1
    m_Heigth = m_Heigth + lblUserName(i).Height + IIf(lbpPhoto(i).Height >= lbpMessage(i).Height, lbpPhoto(i).Height, lbpMessage(i).Height) + MarginTop
  Next
  
  With ucScrollbar1
    If m_Heigth < UserControl.ScaleHeight Then
      .Visible = False
    Else
      .Max = m_Heigth - UserControl.ScaleHeight + MarginTop
      .LargeChange = UserControl.ScaleHeight / 5
      .SmallChange = lblUserName(1).Height + 1 + IIf(lbpPhoto(1).Height >= lbpMessage(1).Height, lbpPhoto(1).Height, lbpMessage(1).Height) + MarginTop * 2
      .Value = ucScrollbar1.Max
      .Visible = True
      .Refresh
    End If
    
    lblUserName(0).Top = -.Value - lblUserName(0).Height
    lblTimeStamp(0).Top = -.Value - lblTimeStamp(0).Height
    lbpPhoto(0).Top = -.Value - lbpPhoto(0).Height
    lbpMessage(0).Top = -.Value - lbpMessage(0).Height
  End With
  
  For i = 1 To lbpMessage.Count - 1
    lblUserName(i).Top = MarginTop + IIf(lbpPhoto(i - 1).Height > lbpMessage(i - 1).Height, lbpPhoto(i - 1).Top + lbpPhoto(i - 1).Height, lbpMessage(i - 1).Top + lbpMessage(i - 1).Height)
    lblTimeStamp(i).Top = lblUserName(i).Top
    lbpPhoto(i).Top = lblUserName(i).Top + lblUserName(i).Height
    lbpMessage(i).Top = lblUserName(i).Top + lblUserName(i).Height
  Next
  
  Call SendMessage(UserControl.hwnd, WM_SETREDRAW, 1&, 0&)
  
  RedrawWindow UserControl.hwnd, ByVal &H0, 0, 1
End Sub


Private Sub ucScrollbar1_Change()
  ucScrollbar1_Scroll
End Sub

Private Sub ucScrollbar1_Scroll()
  Dim i As Long
  
  Call SendMessage(UserControl.hwnd, WM_SETREDRAW, 0&, 0&)
  
  With ucScrollbar1
    lblUserName(0).Top = -.Value - lblUserName(0).Height
    lbpPhoto(0).Top = -.Value - lbpPhoto(0).Height
    lbpMessage(0).Top = -.Value - lbpMessage(0).Height
  End With
  
  For i = 1 To lbpMessage.Count - 1
    lblUserName(i).Top = MarginTop + IIf(lbpPhoto(i - 1).Height > lbpMessage(i - 1).Height, lbpPhoto(i - 1).Top + lbpPhoto(i - 1).Height, lbpMessage(i - 1).Top + lbpMessage(i - 1).Height)
    lblTimeStamp(i).Top = lblUserName(i).Top
    lbpPhoto(i).Top = lblUserName(i).Top + lblUserName(i).Height
    lbpMessage(i).Top = lblUserName(i).Top + lblUserName(i).Height
  Next
  
  Call SendMessage(UserControl.hwnd, WM_SETREDRAW, 1&, 0&)
  
  RedrawWindow UserControl.hwnd, ByVal &H0, 0, 1
End Sub

Private Sub UserControl_Resize()
  ucScrollbar1.Move UserControl.ScaleWidth - ucScrollbar1.Width, 0, ucScrollbar1.Width, UserControl.ScaleHeight
  ucScrollbar1.Refresh
End Sub

Public Function MsgCount() As Long
  MsgCount = lbpMessage.Count
End Function

Public Sub Clear()
  Dim i As Long
  
  Call SendMessage(UserControl.hwnd, WM_SETREDRAW, 0&, 0&)
  
  
  For i = lblUserName.Count - 1 To 1 Step -1
    Unload lblUserName(i)
  Next
  
  For i = lblTimeStamp.Count - 1 To 1 Step -1
    Unload lblTimeStamp(i)
  Next
  
  For i = lbpPhoto.Count - 1 To 1 Step -1
    Unload lbpPhoto(i)
  Next
  
  For i = lbpMessage.Count - 1 To 1 Step -1
    Unload lbpMessage(i)
  Next
  
  ucScrollbar1.Value = 0
  ucScrollbar1.Max = 10
  ucScrollbar1.Visible = False
  
  Call SendMessage(UserControl.hwnd, WM_SETREDRAW, 1&, 0&)
  
   RedrawWindow UserControl.hwnd, ByVal &H0, 0, 1
End Sub

Private Sub UserControl_Show()
  DpiZoom = lbpMessage(0).GetWindowsDPI
  MarginTop = 10 * DpiZoom
  ucScrollbar1.Refresh
End Sub

Public Function CapitalizeFirstWord(ByVal strSentence As String, Optional ByVal All As Boolean = True)
  Dim i As Long
  Dim strTemp As String
  Dim intLocation As Long
  Dim strChar As String * 1
  
  If All Then
    strTemp = vbNullString
    For i = 1 To Len(strSentence)
      strChar = Chr(Asc(Mid(strSentence, i, 1)))
      If Len(Trim(strChar)) < 1 Then
        intLocation = i + 1
      End If
      If i = intLocation Or i = 1 Then
        strTemp = strTemp + UCase(Chr(Asc(Mid(strSentence, i, 1))))
      Else
        strTemp = strTemp + LCase(Chr(Asc(Mid(strSentence, i, 1))))
      End If
    Next
  Else
    strTemp = UCase$(Left$(strSentence, 1)) & LCase$(Mid$(strSentence, 2))
  End If
  CapitalizeFirstWord = strTemp
End Function
